package com.zipcoder.payment.main.payment;


public class Check implements Payment{
    Long id;
    String payerName;
    String routingNumber;
    String accountNumber;


    public Check () {}

    public Check(Long id, String payerName, String routingNumber, String accountNumber){
        this.id = id; this.payerName = payerName;
        this.accountNumber = lastFourAccount(accountNumber); this.routingNumber = routingNumber;
    }

    @Override
    public long getId() {
        return id;
    }

    public void setId(Long id){
        this.id = id;
    }

    @Override
    public String getPayerName() {
        return payerName;
    }

    public void setPayerName(String payerName) {
        this.payerName = payerName;
    }

    public String lastFourAccount(String accountNumber){
        return accountNumber.replace(accountNumber.substring(0, accountNumber.length()-4), "");

    }

    @Override
    public String getShortDescription() {
        return "Check " + getPayerName() + " ***" + getAccountNumber();
    }

    public String getRoutingNumber() {
        return routingNumber;
    }

    public void setRoutingNumber(String routingNumber) {
        this.routingNumber = routingNumber;
    }

    public String getAccountNumber() {
        return accountNumber;
    }

    public void setAccountNumber(String accountNumber) {
        this.accountNumber = accountNumber;

    }


    @Override
    public int compareTo(Payment o) {

        if (this.getShortDescription().compareToIgnoreCase(o.getShortDescription()) < 0) return -1;
            else if (this.getShortDescription().compareToIgnoreCase(o.getShortDescription()) > 0) return 1;
                else return 0;
    }
}
