package com.zipcoder;

import com.zipcoder.payment.main.payment.Check;
import com.zipcoder.payment.main.payment.CreditCard;
import com.zipcoder.payment.main.payment.Paypal;
import org.junit.Test;

import static org.junit.Assert.assertEquals;

public class CheckTest {
    Check check = new Check();
    Paypal pay = new Paypal();
    CreditCard card = new CreditCard();

    @Test
    public void getId() {
        long expectedId = 3765;
        check.setId(expectedId);

        long actualId = check.getId();

        assertEquals(expectedId, actualId);
    }

    @Test
    public void getPayerName() {
        String expectedPayerName = "Tammy Jammy";
        check.setPayerName(expectedPayerName);

        String actualPayerName = check.getPayerName();

        assertEquals(expectedPayerName, actualPayerName);

    }

    @Test
    public void getShortDescription() {
        String name = "Tammy Jammy";
        String accountNumber = "4551";
        check.setPayerName(name);
        check.setAccountNumber(accountNumber);


        String expectedDescription = "Check " + name +  " ***" + accountNumber;

        System.out.println(check.getShortDescription());
        String actualDescription = check.getShortDescription();

        assertEquals(expectedDescription, actualDescription);
    }

    @Test
    public void getRoutingNumber() {
        String expectedRoutingNumber = "123456789";
        check.setRoutingNumber(expectedRoutingNumber);

        String actualRoutingNumber= check.getRoutingNumber();

        assertEquals(expectedRoutingNumber, actualRoutingNumber);

    }

    @Test
    public void getAccountNumber(){
        Check check = new Check();

        String expectedAccountNumber = "4551";
        check.setAccountNumber(expectedAccountNumber);

        String actualAccountNumber= check.getAccountNumber();

        assertEquals(expectedAccountNumber, actualAccountNumber);

    }
    @Test
    public void compareToPaypal() {
        Check check = new Check();
        Paypal pay = new Paypal();

        int expected = -1;
        int actual = (check.compareTo(pay));


        assertEquals(expected, actual);
    }

    @Test
    public void compareToCredit() {
        Check check = new Check();
        CreditCard card = new CreditCard();

        int expected = 1;
        int actual = (check.compareTo(card));


        assertEquals(expected, actual);
    }

    @Test
    public void compareToSelf() {
        Check check = new Check();

        int expected = 0;
        int actual = (check.compareTo(check));


        assertEquals(expected, actual);
    }

    @Test
    public void lastFourAccount() {
        String x = "1234567";

        String expected = "4567";
        String actual = check.lastFourAccount(x);

        assertEquals(expected, actual);
    }
}