package com.zipcoder;

import com.zipcoder.payment.main.payment.Check;
import com.zipcoder.payment.main.payment.CreditCard;
import com.zipcoder.payment.main.payment.Paypal;
import org.junit.Test;

import static org.junit.Assert.assertEquals;

public class CreditCardTest {
    Paypal pay = new Paypal();
    Check check = new Check();
    CreditCard card = new CreditCard();

    @org.junit.Test
    public void setId() {
        CreditCard credit = new CreditCard();

        long expectedId = 2019;
        credit.setId(expectedId);

        long actualId = credit.getId();

        assertEquals(expectedId, actualId);
    }

    @org.junit.Test
    public void setPayerName() {
        CreditCard credit = new CreditCard();


        String expectedPayerName = "James Goslin";
        credit.setPayerName(expectedPayerName);

        String actualPayerName = credit.getPayerName();

        assertEquals(expectedPayerName, actualPayerName);
    }

    @org.junit.Test
    public void getShortDescription() {
        CreditCard credit = new CreditCard();

        String name = "Tammy Jammy";
        String accountNumber = "4551";
        Integer month = 10;
        Integer year = 2019;

        credit.setPayerName(name);
        credit.setNumber(accountNumber);
        credit.setExpiredMonth(month);
        credit.setExpiredYear(year);


        String expectedDescription = "CC " + name + " " + accountNumber
                + " " + month + "/" + year;

        System.out.println(credit.getShortDescription());
        String actualDescription = credit.getShortDescription();

        assertEquals(expectedDescription, actualDescription);
    }

    @org.junit.Test
    public void getExpiredMonth() {
        CreditCard credit = new CreditCard();

        int expectedExpMonth = 10;
        credit.setExpiredMonth(expectedExpMonth);

        int actualExpMonth = credit.getExpiredMonth();

        assertEquals(expectedExpMonth, actualExpMonth);

    }

    @org.junit.Test
    public void getExpiredYear() {
        CreditCard credit = new CreditCard();

        int expectedExpYear = 2019;
        credit.setExpiredYear(expectedExpYear);

        int actualExpYear = credit.getExpiredYear();

        assertEquals(expectedExpYear, actualExpYear);

    }

    @org.junit.Test
    public void setNumber() {
        CreditCard credit = new CreditCard();

        String expectedNumber = "7890";
        credit.setNumber(expectedNumber);

        String actualNumber = credit.getNumber();

        assertEquals(expectedNumber, actualNumber);

    }

    @Test
    public void compareToSelf() {
        int expected = 0;
        int actual = card.compareTo(card);

        assertEquals(expected, actual);

    }

    @Test
    public void compareToCheck(){
        int expected = -1;
        int actual = card.compareTo(check);

        System.out.println(card.compareTo(check));
        assertEquals(expected, actual);

    }

    @Test
    public void compareToPaypal(){
        int expected = -1;
        int actual = card.compareTo(pay);

        assertEquals(expected, actual);

    }
}