package com.zipcoder;

import com.zipcoder.payment.main.payment.Check;
import com.zipcoder.payment.main.payment.Payment;
import com.zipcoder.payment.main.payment.PaymentPresenter;
import com.zipcoder.payment.main.payment.Paypal;
import org.junit.Test;

import static junit.framework.TestCase.assertEquals;

public class PaymentPresenterTest {

    @Test
    public void toStringNoPayments() {
        Payment[] payments = new Payment[0];
        PaymentPresenter presenter = new PaymentPresenter();
        String expected = "";

        String actual = presenter.toString(payments);

        assertEquals(expected, actual);

    }

    @Test
    public void toStringMultiplePayments() {
        Payment[] payment = new Payment[2];
        Payment paypal = new Paypal(4L, "Tia Mowry", "tia@mowry.com");
        Payment check = new Check(81L, "Tia Mowry", "11432543", "134344551");


        payment[0] = paypal;
        payment[1] = check;

        PaymentPresenter presenter = new PaymentPresenter();
        String expected = "Check Tia Mowry ***4551\nPaypal Tia Mowry tia@mowry.com\n";

        String actual = presenter.toString(payment);
        assertEquals(expected, actual);
    }

    @Test
    public void toStringByPayerName() {
        Payment[] payment = new Payment[2];
        Payment paypal = new Paypal(4L, "Tamara Mowry", "tamara@mowry.com");
        Payment check = new Check(81L, "Tia Mowry", "11432543", "134344551");

        payment[0] = paypal;
        payment[1] = check;

        PaymentPresenter presenter = new PaymentPresenter();
        String expected = "Paypal Tamara Mowry tamara@mowry.com\nCheck Tia Mowry ***4551\n";

        String actual = presenter.toStringByPayerName(payment);
        assertEquals(expected, actual);
    }

    @Test
    public void toStringById() {
        Payment[] payment = new Payment[2];
        Payment paypal = new Paypal(120L, "Tamara Mowry", "tamara@mowry.com");
        Payment check = new Check(81L, "Tia Mowry", "11432543", "134344551");

        payment[0] = paypal;
        payment[1] = check;

        PaymentPresenter presenter = new PaymentPresenter();
        String expected = "Check Tia Mowry ***4551\nPaypal Tamara Mowry tamara@mowry.com\n";

        String actual = presenter.toStringById(payment);
        assertEquals(expected, actual);

    }
}


