package com.zipcoder;

import com.zipcoder.payment.main.payment.Check;
import com.zipcoder.payment.main.payment.CreditCard;
import com.zipcoder.payment.main.payment.Paypal;
import org.junit.Test;

import static org.junit.Assert.assertEquals;

public class PaypalTest {

    @Test
    public void getId() {
        Paypal pay = new Paypal();

        long expectedId = 6478;
        pay.setId(expectedId);

        long actualId = pay.getId();

        assertEquals(expectedId, actualId);
    }

    @Test
    public void getPayerName() {
        Paypal pay = new Paypal();

        String expectedName = "Andre Baugher";
        pay.setPayerName(expectedName);

        String actualName = pay.getPayerName();

        assertEquals(expectedName, actualName);
    }

    @Test
    public void getShortDescription() {
        Paypal pay = new Paypal();

        String name = "Andre Baugher";
        String email = "scoopDAwoop82@woopty.com";

        pay.setPayerName(name);
        pay.setEmail(email);

        String expectedDescription = "Paypal " + name + " " + email;
        String actualDescription = pay.getShortDescription();

        assertEquals(expectedDescription, actualDescription);
    }

    @Test
    public void getEmail() {
        Paypal pay = new Paypal();

        String expectedMail = "scoopDAwoop82@woopty.com";
        pay.setEmail(expectedMail);

        String actualMail = pay.getEmail();

        assertEquals(expectedMail, actualMail);
    }

    @Test
    public void compareToCheck() {
        Paypal pay = new Paypal();
        Check check = new Check();

        int expected = 1;
        int actual = (pay.compareTo(check));


        assertEquals(expected, actual);
    }

    @Test
    public void compareToCredit() {
        Paypal pay = new Paypal();
        CreditCard card = new CreditCard();

        int expected = 1;
        int actual = (pay.compareTo(card));


        assertEquals(expected, actual);
    }

    @Test
    public void compareToSelf() {
        Paypal pay = new Paypal();

        int expected = 0;
        int actual = (pay.compareTo(pay));


        assertEquals(expected, actual);
    }

}